
import java.util.*;

/**
 *  Description of the Class
 *
 * @author     Silvio Evangelista
 * @created    10 de Setembro de 2008
 */
public class HTMessage {

    int numLines = 0;
    int maximumWidth = 0;
    int idM = 0;
    private String asLinhas[];

    /**
     *Constructor for the HTMessage object
     *
     * @param  m  Description of the Parameter
     */
    public HTMessage(String m) {

        String linha;
        int ind;

//		StringTokenizer tokenizer = new StringTokenizer(m, "&");

        if (m.trim().length() > 1) {
            numLines = 1;
        } else {
            numLines =0;
        }
        int iT = m.indexOf("&crlf");

        String asLinhasT[] = new String[128];


        if (iT < 0) {
            asLinhasT[0] = m;
        } else {
            asLinhasT[0] = m.substring(0, iT);
        }
	  asLinhasT[1]= " ";
	  numLines++; 
        for (; iT < m.length() && iT > -1 && numLines < 128;) {
            m = m.substring(iT + 5);
            iT = m.indexOf("&crlf");
            if (m == null) {
                m = "";
            }
            if (iT > 0) {
                asLinhasT[numLines] = m.substring(0, iT);
            } else {
                asLinhasT[numLines] = m;
            }
            numLines++;
        }

        asLinhas = new String[numLines];

        for (int i = 0; i < numLines; i++) {
            asLinhas[i] = asLinhasT[i];
        }

        /*
         *  numLines = tokenizer.countTokens();
         *  int index;
         *  asLinhas = new String[ numLines];
         *  int nl=0;
         *  for ( index =0; index < numLines; index++){
         *  linha = ((String) tokenizer.nextToken());
         *  ind   = linha.toLowerCase().indexOf("crlf");
         *  if (ind > -1) {
         *  ind += 4;
         *  if (linha.length() > 4)
         *  asLinhas[index] = linha.substring(ind).trim(); //index
         *  else
         *  asLinhas[index] = ""; //index
         *  nl++;
         *  }
         *  else {
         *  /if (nl > 0)
         *  /	asLinhas[nl-1] = asLinhas[nl-1] + "&" + linha.trim(); //
         *  /else
         *  asLinhas[index] = linha.trim(); // index
         *  }
         *  } // End for.
         *  /numLines = nl+1;
         */
        setSizes();
    }
    // End
    /**
     *  Sets the sizes attribute of the HTMessage object
     */
    private void setSizes() {
        int thisWidth;
        int index;
        for (index = 0; index < numLines; index++) {
            thisWidth = asLinhas[index].length();
            if (thisWidth > maximumWidth) {
                maximumWidth = thisWidth;
                idM = index;
            }
        }
    }
    // End setSizes.
    /**
     *  Gets the idM attribute of the HTMessage object
     *
     * @return    The idM value
     */
    public int getIdM() {
        return idM;
    }

    /**
     *  Gets the line attribute of the HTMessage object
     *
     * @param  i  Description of the Parameter
     * @return    The line value
     */
    public String getLine(int i) {
        return (asLinhas[i]);
    }

    /**
     *  Gets the numLines attribute of the HTMessage object
     *
     * @return    The numLines value
     */
    public int getNumLines() {
        return numLines;
    }

    /**
     *  Gets the maximumWidth attribute of the HTMessage object
     *
     * @return    The maximumWidth value
     */
    public int getMaximumWidth() {
        return maximumWidth;
    }
}

